((LitElement) => {
  const html = LitElement.prototype.html;
  const css = LitElement.prototype.css;

  class EmailSensorCard extends LitElement {

      static get properties() {
          return {
              _hass: {},
              _config: {},
              stateObj: {},
              state: {},
              style: {}
          }
      }

      static get styles() {
          return css`
          
      .background {
        background-repeat: no-repeat;
        background-position: center center;
        background-size: cover;
      }

      `;
      }

      render() {
          return html`
          <ha-card .hass="${this._hass}" .config="${this._config}" class="background">

          </ha-card>`;
      }

      getValue(field) {

          // if((this.state.attributes[field] === 'total_header') || (this.state.attributes[field] === 'job_header')){
          //   return `${this.state.labels[field]}:`;
          // }

          const value = (this.stateObj && this.state.attributes[field] in this.stateObj.attributes)
              ? this.stateObj.attributes[this.state.attributes[field]]
              : (this._hass ? this._hass.localize('state.default.unavailable') : 'Unavailable');
          return `${this.state.labels[field]}: ${value}`;
      };

      getState(field) {
        const value = this.stateObj.state;
        
        return `${this.state.labels[field]}: ${value}`;
      };

      fireEvent(type, options = {}) {
          const event = new Event(type, { bubbles: options.bubbles || true, cancelable: options.cancelable || true, composed: options.composed || true });
          event.detail = {entityId: this.stateObj.entity_id};
          this.dispatchEvent(event);
      }

      getCardSize() {
          return 7;
      }

      setConfig(config) {
          const labels = {
              status: 'Status',
              mode: 'Mode',
              battery: 'Battery',
              bin: 'Bin',
              total_time: 'Time',
              total_jobs: 'Jobs',
              dirt_events: 'Dirts',
              job_initiator: 'Source',
              job_time: 'Time',
              total_header: 'Total',
              job_header: 'Job',
              full_clean: 'Full Clean',
              resume_clean: 'Resume',
              pause_clean: 'Pause',
              stop_clean: 'Stop',
              dock: 'Dock',
              bin_missing: 'Missing!'
          };

          const iphone_states = {
            ready: 'Ready',
            stuck: 'Stuck',
            pending: 'Pending',
            charge: 'Charge',
            idle: 'Idle',
            empty: 'Empty',
            paused: 'Paused'
          };

          const attributes = {
              status: 'state',
              battery: 'battery',
              mode: 'phase',
              bin: 'bin',
              bin_present: 'bin_present',
              total_time: 'total_time',
              total_jobs: 'total_jobs',
              dirt_events: 'dirt_events',
              job_initiator: 'job_initiator',
              job_time: 'job_time',
              total_header: 'total_header',
              job_header: 'job_header',
              full_clean: 'full_clean',
              resume_clean: 'resume_clean',
              pause_clean: 'pause_clean',
              stop_clean: 'stop_clean',
              dock: 'dock',
              bin_missing: 'bin_missing'
          };

          if (!config.entity) throw new Error('Please define an entity.');
          if (config.entity.split('.')[0] !== 'sensor') throw new Error('Please define a sensor entity.');

          this.state = {
              showName: config.name !== false,
              showTitle: config.name !== false,

              attributes: Object.assign({}, attributes, config.attributes),
              iphone_states: Object.assign({}, iphone_states, config.iphone_states),
              labels: Object.assign({}, labels, config.labels),
          };

          this.style = {
              text: `cursor: pointer;`,
          };

          this._config = config;
      }

      set hass(hass) {
          this._hass = hass;

          if (hass && this._config) {
              this.stateObj = this._config.entity in hass.states ? hass.states[this._config.entity] : null;

              if (this.stateObj && this.state.showName) {
                  this.state.name = this._config.name || this.stateObj.attributes.friendly_name;
              }
          }
      }
  }

  customElements.define('email-sensor-card', EmailSensorCard);
})(window.LitElement || Object.getPrototypeOf(customElements.get("hui-view")));