((LitElement) => {
    const html = LitElement.prototype.html;
    const css = LitElement.prototype.css;
  
    class SimpleClockDateCard extends LitElement {
  
        static get properties() {
            return {
                _hass: {},
                _config: {},
                stateObj: {},
                state: {},
                style: {}
            }
        }
  
        static get styles() {
            return css`
            .card { 
                cursor: default; 
            }
            .content { 
                padding: 10px 20px 10px; 
            }
            .main { 
                display: flex; width: 100%; 
                justify-content: space-between; 
                align-items: center; 
            }
            .clockBox { 
                font-size: 32px !important; 
                font-family: var(--paper-font-headline_-_font-family); 
                -webkit-font-smoothing: var(--paper-font-headline_-_-webkit-font-smoothing);
                font-size: var(--paper-font-headline_-_font-size); 
                font-weight: var(--paper-font-headline_-_font-weight); 
                letter-spacing: var(--paper-font-headline_-_letter-spacing);
                line-height: var(--paper-font-headline_-_line-height); 
                text-rendering: var(--paper-font-common-expensive-kerning_-_text-rendering); 
                opacity: var(--dark-primary-opacity); 
            }
            .dateBox {
                font-size: 20px !important; 
                font-family: var(--paper-font-headline_-_font-family); 
                -webkit-font-smoothing: var(--paper-font-headline_-_-webkit-font-smoothing);
                font-size: var(--paper-font-headline_-_font-size); 
                font-weight: var(--paper-font-headline_-_font-weight); 
                letter-spacing: var(--paper-font-headline_-_letter-spacing);
                line-height: var(--paper-font-headline_-_line-height); 
                text-rendering: var(--paper-font-common-expensive-kerning_-_text-rendering); 
                opacity: var(--dark-primary-opacity); 
            }
        `;
        }
  
        render() {
            return html`
            <ha-card .hass="${this._hass}" .config="${this._config}" class="card">
                <div class="content">
                    <div class="main">
                        <div class="clockBox">
                            <div id="time">
                                <ha-icon style="padding-right: 10px; transform: scale(1.25) translateY(-3px);" icon="mdi:clock-outline"></ha-icon>
                                ${this.getValue('time')}
                            </div>
                        </div>
                        <div class="dateBox">
                            <div id="date">
                                ${this.getValue('date')}
                                <ha-icon style="padding-left: 10px; transform: scale(1.25) translateY(-2px);" icon="mdi:calendar-today"></ha-icon>
                            </div>
                        </div>
                    </div>
                </div>
            </ha-card>`;
        }
  
        getValue(field) {
            const withLeadingZero = (x) => (x < 10) ? `0${x}` : x;
            const dateTime = new Date(`${this.stateObj.state}`);
            const dateOnly = `${withLeadingZero(dateTime.getDate())}${this.state.attributes['date_splitter']}${withLeadingZero(dateTime.getMonth()+1)}${this.state.attributes['date_splitter']}${dateTime.getFullYear()}`
            // const timeOnly = `${withLeadingZero(dateTime.getHours())}${this.state.attributes['time_splitter']}${withLeadingZero(dateTime.getMinutes())}${this.state.attributes['time_splitter']}${withLeadingZero(dateTime.getSeconds())}`
            const timeOnly = `${withLeadingZero(dateTime.getHours())}${this.state.attributes['time_splitter']}${withLeadingZero(dateTime.getMinutes())}`
            if(field === 'time'){ return timeOnly }
            if(field === 'date'){ return dateOnly }
        };
  
        getCardSize() {
            return 2;
        }
  
        setConfig(config) {
            const attributes = {
                date_splitter: '.',
                time_splitter: ':'
            };
  
            if (!config.entity) throw new Error('Please define an entity.');
            if (config.entity.split('.')[0] !== 'sensor') throw new Error('Please define a sensor entity.');
  
            this.state = {
                attributes: Object.assign({}, attributes, config.attributes)
            };
  
            this._config = config;
        }
  
        set hass(hass) {
            this._hass = hass;
  
            if (hass && this._config) {
                this.stateObj = this._config.entity in hass.states ? hass.states[this._config.entity] : null;
            }
        }
    }
  
    customElements.define('simple-clock-date-card', SimpleClockDateCard);
  })(window.LitElement || Object.getPrototypeOf(customElements.get("hui-view")));